#include "xparameters.h"
#include "mb_interface.h"
#include "stdio.h"
#include "xgpio.h"
#include "xutil.h"
#include "npi.h"

int main() 
{
	XGpio Gpio; 
	volatile int Status, i, *add;
	int burst_repeat_cnt, acnt;
	XGpio *gpio;

	Status = XGpio_Initialize(&Gpio, XPAR_XPS_GPIO_0_DEVICE_ID);
	if (Status != XST_SUCCESS) {
		return XST_FAILURE;
	}

	for(i = 0; i < 10; i++) 
		XGpio_DiscreteWrite(&Gpio, 1, i); 

	XGpio_DiscreteWrite(&Gpio, 1, 3); 
	while(!npi_init_done(XPAR_NPI_USER_IF_0_BASEADDR));
	XGpio_DiscreteWrite(&Gpio, 1, 4); 
	while(!npi_init_done(XPAR_NPI_USER_IF_1_BASEADDR));

	XGpio_DiscreteWrite(&Gpio, 1, 5); 
	add = (volatile int *)XPAR_DDR2_SDRAM_16MX32_MPMC_BASEADDR;

	for(i = 0; i < 0x100; i++)
		*add++ = i + 0x80000000;

	XGpio_DiscreteWrite(&Gpio, 1, 6); 
	while(!npi_cmd_wait(XPAR_NPI_USER_IF_0_BASEADDR)); 
	while(!npi_cmd_wait(XPAR_NPI_USER_IF_1_BASEADDR)); 
	npi_cmd(XPAR_NPI_USER_IF_1_BASEADDR, XPAR_DDR2_SDRAM_16MX32_MPMC_BASEADDR + 0x01000000, 0x4, 0x3, NPI_CMD_WR);
	XGpio_DiscreteWrite(&Gpio, 1, 7); 
	npi_cmd(XPAR_NPI_USER_IF_0_BASEADDR, XPAR_DDR2_SDRAM_16MX32_MPMC_BASEADDR + 0x00000000, 0x4, 0x3, NPI_CMD_RD);
	XGpio_DiscreteWrite(&Gpio, 1, 8); 
	return 1;
}

