#include "xparameters.h"
#include "npi.h"

/***********************************************************************************************************************************/
/* check wether mpmc is able to access external ddr# ram */
/* argument : int npi_add, base address of NPI_USER_LOGIC */
/***********************************************************************************************************************************/
int npi_init_done(int npi_add)
{
	int *add;

	add = (int *)(npi_add);
	if((*add & NPI_ST_INIT_DONE) == NPI_ST_INIT_DONE)	
		return 1;
	else
		return 0;
}

/***********************************************************************************************************************************/
/* check wether npi is waiting rd, wr or rst cmd */ 
/* argument : int npi_add, base address of NPI_USER_LOGIC */
/***********************************************************************************************************************************/
int npi_cmd_wait(int npi_add)
{
	int *add;
	add = (int *)(npi_add+ NPI_REG_SM_STATUS);
	if(*add == NPI_SM_WAIT_COMMAND)
		return 1;
	else
		return 0;
}
/***********************************************************************************************************************************/
/* ask npi user logic to rd, wr or rst */ 
/* argument : int npi_add, base address of NPI_USER_LOGIC */
/* argument : int ram_add, external memory address 
 *            for wr case : npi_user_logic will write data to   ram_add
 *            for rd case : npi_user_logic will read  data from ram_add 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! *
 *            only high 8 bits is avaiable
 *            ex) ram_add = 0x12345678 ===> it translate into 0x12000000
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! *
 *
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! *
!!!!!!!!!!!!!!!!!!! *            very very very very very important
 * argument : int cnt : burst count, each burst consists with 16 times rd or wr transaction and each transaction is 64bits (8bytes)
 *            so the npi_user_logic will access from ram_add to ram_add + cnt * 16 * 8
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! *
 * argument : int repeat: repeat number : npi will repeat same operation (rd, wr) from ram_add to ram_add + cnt*16*8 
 * argument : int cmd : rd, wr or rst */            
/***********************************************************************************************************************************/
void npi_cmd(int npi_add, int ram_add, int cnt, int repeat, int cmd)
{
	int *add;

	add = (int *)npi_add;
	*add++ = ram_add; 
	*add++ = cnt;
	*add++ = repeat;
	*add++ = cmd;
}

int npi_get_sm_status(int npi_add)
{
	int *add;

	add = (int *)(npi_add + NPI_REG_SM_STATUS);	

	return *add & 0xff;

}

int npi_get_npi_status(int npi_add)
{
	int *add;

	add = (int *)(npi_add + NPI_REG_STATUS);

	return *add & 0xff;

}

int npi_get_burst(int npi_add)
{
	int *add;

	add = (int *)(npi_add + NPI_REG_BURST);	

	return *add & 0xffff;

}

int npi_get_add_cnt(int npi_add)
{
	int *add;

	add = (int *)(npi_add + NPI_REG_ADD_CNT);

	return *add & 0xffff;

}


